Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/ProblemType.cs
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/ProblemType.cs	(revision 16581)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/ProblemType.cs	(revision 16582)
@@ -20,5 +20,5 @@
 #endregion
 
-namespace HeuristicLab.MathematicalOptimization.LinearProgramming {
+namespace HeuristicLab.ExactOptimization.LinearProgramming {
 
   public enum ProblemType {
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/ProtoWriteFormat.cs
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/ProtoWriteFormat.cs	(revision 16581)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/ProtoWriteFormat.cs	(revision 16582)
@@ -20,5 +20,5 @@
 #endregion
 
-namespace HeuristicLab.MathematicalOptimization.LinearProgramming {
+namespace HeuristicLab.ExactOptimization.LinearProgramming {
 
   public enum ProtoWriteFormat {
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/ResultStatus.cs
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/ResultStatus.cs	(revision 16581)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/ResultStatus.cs	(revision 16582)
@@ -1,34 +1,13 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
+﻿namespace HeuristicLab.ExactOptimization.LinearProgramming {
 
-namespace HeuristicLab.MathematicalOptimization.LinearProgramming {
-
-  // The status of solving the problem.
   public enum ResultStatus {
-    Optimal,       // optimal.
-    Feasible,      // feasible, or stopped by limit.
-    Infeasible,    // proven infeasible.
-    Unbounded,     // proven unbounded.
-    Abnormal,      // abnormal, i.e., error of some kind.
-    ModelInvalid,  // the model is trivially invalid (NaN coefficients, etc).
-    NotSolved = 6  // not been solved yet.
+    Optimal,        // optimal.
+    Feasible,       // feasible, or stopped by limit.
+    Infeasible,     // proven infeasible.
+    Unbounded,      // proven unbounded.
+    Abnormal,       // abnormal, i.e., error of some kind.
+    ModelInvalid,   // the model is trivially invalid (NaN coefficients, etc).
+    NotSolved = 6,  // not been solved yet.
+    OptimalWithinTolerance = int.MaxValue  // optimal within gap tolerance but objective != bound
   }
 }
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/SolverResponseStatus.cs
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/SolverResponseStatus.cs	(revision 16581)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/SolverResponseStatus.cs	(revision 16582)
@@ -20,5 +20,7 @@
 #endregion
 
-namespace HeuristicLab.MathematicalOptimization.LinearProgramming {
+using Google.OrTools.LinearSolver;
+
+namespace HeuristicLab.ExactOptimization.LinearProgramming {
 
   public enum SolverResponseStatus {
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/ExternalIncrementalLinearSolver.cs
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/ExternalIncrementalLinearSolver.cs	(revision 16581)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/ExternalIncrementalLinearSolver.cs	(revision 16582)
@@ -26,5 +26,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.MathematicalOptimization.LinearProgramming {
+namespace HeuristicLab.ExactOptimization.LinearProgramming {
 
   [StorableClass]
@@ -53,5 +53,7 @@
     }
 
-    protected override Solver CreateSolver(OptimizationProblemType optimizationProblemType,
+    public IFixedValueParameter<FileValue> LibraryNameParameter => libraryNameParam;
+
+    protected override Solver CreateSolver(Solver.OptimizationProblemType optimizationProblemType,
       string libraryName = null) => base.CreateSolver(optimizationProblemType, LibraryName);
   }
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/ExternalLinearSolver.cs
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/ExternalLinearSolver.cs	(revision 16581)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/ExternalLinearSolver.cs	(revision 16582)
@@ -26,5 +26,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.MathematicalOptimization.LinearProgramming {
+namespace HeuristicLab.ExactOptimization.LinearProgramming {
 
   [StorableClass]
@@ -53,5 +53,7 @@
     }
 
-    protected override Solver CreateSolver(OptimizationProblemType optimizationProblemType,
+    public IFixedValueParameter<FileValue> LibraryNameParameter => libraryNameParam;
+
+    protected override Solver CreateSolver(Solver.OptimizationProblemType optimizationProblemType,
       string libraryName = null) => base.CreateSolver(optimizationProblemType, LibraryName);
   }
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/IExternalLinearSolver.cs
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/IExternalLinearSolver.cs	(revision 16581)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/IExternalLinearSolver.cs	(revision 16582)
@@ -20,5 +20,5 @@
 #endregion
 
-namespace HeuristicLab.MathematicalOptimization.LinearProgramming {
+namespace HeuristicLab.ExactOptimization.LinearProgramming {
 
   public interface IExternalLinearSolver : ILinearSolver {
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/IIncrementalLinearSolver.cs
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/IIncrementalLinearSolver.cs	(revision 16581)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/IIncrementalLinearSolver.cs	(revision 16582)
@@ -22,5 +22,5 @@
 using System;
 
-namespace HeuristicLab.MathematicalOptimization.LinearProgramming {
+namespace HeuristicLab.ExactOptimization.LinearProgramming {
 
   public interface IIncrementalLinearSolver : ILinearSolver {
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/ILinearSolver.cs
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/ILinearSolver.cs	(revision 16581)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/ILinearSolver.cs	(revision 16582)
@@ -25,14 +25,8 @@
 using HeuristicLab.Optimization;
 
-namespace HeuristicLab.MathematicalOptimization.LinearProgramming {
+namespace HeuristicLab.ExactOptimization.LinearProgramming {
 
   public interface ILinearSolver : IParameterizedNamedItem {
     double DualTolerance { get; set; }
-
-    string ExportModel { get; set; }
-
-    bool Incrementality { get; set; }
-
-    LpAlgorithmValues LpAlgorithm { get; set; }
 
     bool Presolve { get; set; }
@@ -56,7 +50,7 @@
     void Reset();
 
-    void Solve(ILinearProgrammingProblemDefinition problemDefintion, ref TimeSpan executionTime, ResultCollection results);
+    void Solve(ILinearProblemDefinition problemDefintion, ResultCollection results);
 
-    void Solve(ILinearProgrammingProblemDefinition problemDefintion, ref TimeSpan executionTime,
+    void Solve(ILinearProblemDefinition problemDefintion,
       ResultCollection results, CancellationToken cancellationToken);
   }
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/IncrementalLinearSolver.cs
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/IncrementalLinearSolver.cs	(revision 16581)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/IncrementalLinearSolver.cs	(revision 16582)
@@ -21,4 +21,5 @@
 
 using System;
+using System.Diagnostics;
 using System.Linq;
 using System.Threading;
@@ -31,15 +32,19 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.MathematicalOptimization.LinearProgramming {
+namespace HeuristicLab.ExactOptimization.LinearProgramming {
 
   [StorableClass]
   public class IncrementalLinearSolver : LinearSolver, IIncrementalLinearSolver {
-    [Storable] protected readonly IValueParameter<TimeSpanValue> qualityUpdateIntervalParam;
 
-    private IndexedDataRow<double> bpcRow;
+    [Storable]
+    protected readonly IValueParameter<TimeSpanValue> qualityUpdateIntervalParam;
 
-    private IndexedDataRow<double> qpcRow;
+    private readonly Stopwatch stopwatch = new Stopwatch();
 
-    [Storable] private IndexedDataTable<double> qualityPerClock;
+    [Storable]
+    private TimeSpan executionTime = TimeSpan.Zero;
+
+    [Storable]
+    private IndexedDataTable<double> qualityPerClock;
 
     public IncrementalLinearSolver() {
@@ -77,11 +82,20 @@
     }
 
+    public IValueParameter<TimeSpanValue> QualityUpdateIntervalParameter => qualityUpdateIntervalParam;
+
     public virtual bool SupportsQualityUpdate => true;
+
     protected virtual TimeSpan IntermediateTimeLimit => QualityUpdateInterval;
 
-    public override void Solve(ILinearProgrammingProblemDefinition problemDefinition, ref TimeSpan executionTime,
+    public override void Reset() {
+      base.Reset();
+      stopwatch.Reset();
+      executionTime = TimeSpan.Zero;
+    }
+
+    public override void Solve(ILinearProblemDefinition problemDefinition,
       ResultCollection results, CancellationToken cancellationToken) {
       if (!SupportsQualityUpdate || QualityUpdateInterval == TimeSpan.Zero) {
-        base.Solve(problemDefinition, ref executionTime, results, cancellationToken);
+        base.Solve(problemDefinition, results, cancellationToken);
         return;
       }
@@ -102,5 +116,8 @@
           return;
 
+        stopwatch.Start();
         Solve(problemDefinition, results, IntermediateTimeLimit);
+        stopwatch.Stop();
+        executionTime += stopwatch.Elapsed;
         UpdateQuality(results, executionTime);
 
@@ -120,9 +137,17 @@
 
     private void UpdateQuality(ResultCollection results, TimeSpan executionTime) {
+      IndexedDataRow<double> qpcRow;
+      IndexedDataRow<double> bpcRow;
+
       if (!results.Exists(r => r.Name == "QualityPerClock")) {
         qualityPerClock = new IndexedDataTable<double>("Quality per Clock");
         qpcRow = new IndexedDataRow<double>("Objective Value");
         bpcRow = new IndexedDataRow<double>("Bound");
+        qualityPerClock.Rows.Add(qpcRow);
+        qualityPerClock.Rows.Add(bpcRow);
         results.AddOrUpdateResult("QualityPerClock", qualityPerClock);
+      } else {
+        qpcRow = qualityPerClock.Rows["Objective Value"];
+        bpcRow = qualityPerClock.Rows["Bound"];
       }
 
@@ -133,5 +158,5 @@
 
       var objective = ((DoubleValue)results["BestObjectiveValue"].Value).Value;
-      var bound = solver.IsMIP() ? ((DoubleValue)results["BestObjectiveBound"].Value).Value : double.NaN;
+      var bound = solver.IsMip() ? ((DoubleValue)results["BestObjectiveBound"].Value).Value : double.NaN;
       var time = executionTime.TotalSeconds;
 
@@ -140,5 +165,4 @@
           qpcRow.Values.Add(Tuple.Create(time, objective));
           qpcRow.Values.Add(Tuple.Create(time, objective));
-          qualityPerClock.Rows.Add(qpcRow);
           results.AddOrUpdateResult("BestObjectiveValueFoundAt", new TimeSpanValue(TimeSpan.FromSeconds(time)));
         }
@@ -152,5 +176,5 @@
       }
 
-      if (!solver.IsMIP())
+      if (!solver.IsMip())
         return;
 
@@ -159,5 +183,4 @@
           bpcRow.Values.Add(Tuple.Create(time, bound));
           bpcRow.Values.Add(Tuple.Create(time, bound));
-          qualityPerClock.Rows.Add(bpcRow);
         }
       } else {
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/LinearSolver.cs
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/LinearSolver.cs	(revision 16581)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/LinearSolver.cs	(revision 16582)
@@ -34,5 +34,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.MathematicalOptimization.LinearProgramming {
+namespace HeuristicLab.ExactOptimization.LinearProgramming {
 
   [StorableClass]
@@ -49,5 +49,6 @@
     public LinearSolver() {
       Parameters.Add(problemTypeParam =
-        new ValueParameter<EnumValue<ProblemType>>(nameof(ProblemType), new EnumValue<ProblemType>()));
+        new ValueParameter<EnumValue<ProblemType>>(nameof(ProblemType),
+          new EnumValue<ProblemType>(ProblemType.MixedIntegerProgramming)));
       Parameters.Add(solverSpecificParametersParam =
         new FixedValueParameter<TextValue>(nameof(SolverSpecificParameters), new TextValue()));
@@ -65,16 +66,13 @@
     }
 
-    public double DualTolerance { get; set; } = MPSolverParameters.kDefaultDualTolerance;
-
-    public string ExportModel { get; set; }
+    public double DualTolerance { get; set; } = SolverParameters.DefaultDualTolerance;
 
     public bool Incrementality { get; set; } =
-          MPSolverParameters.kDefaultIncrementality == MPSolverParameters.INCREMENTALITY_ON;
-
-    public LpAlgorithmValues LpAlgorithm { get; set; }
-
-    public bool Presolve { get; set; } = MPSolverParameters.kDefaultPresolve == MPSolverParameters.PRESOLVE_ON;
-
-    public double PrimalTolerance { get; set; } = MPSolverParameters.kDefaultPrimalTolerance;
+      SolverParameters.DefaultIncrementality == SolverParameters.IncrementalityValues.IncrementalityOn;
+
+    public SolverParameters.LpAlgorithmValues LpAlgorithm { get; set; }
+    protected virtual Solver.OptimizationProblemType OptimizationProblemType { get; }
+    public bool Presolve { get; set; } = SolverParameters.DefaultPresolve == SolverParameters.PresolveValues.PresolveOn;
+    public double PrimalTolerance { get; set; } = SolverParameters.DefaultPrimalTolerance;
 
     public ProblemType ProblemType {
@@ -83,6 +81,6 @@
     }
 
-    public double RelativeGapTolerance { get; set; } = MPSolverParameters.kDefaultRelativeMipGap;
-
+    public IValueParameter<EnumValue<ProblemType>> ProblemTypeParameter => problemTypeParam;
+    public double RelativeGapTolerance { get; set; } = SolverParameters.DefaultRelativeMipGap;
     public bool Scaling { get; set; }
 
@@ -92,8 +90,8 @@
     }
 
+    public IFixedValueParameter<TextValue> SolverSpecificParametersParameter => solverSpecificParametersParam;
     public virtual bool SupportsPause => true;
     public virtual bool SupportsStop => true;
     public virtual TimeSpan TimeLimit { get; set; } = TimeSpan.Zero;
-    protected virtual OptimizationProblemType OptimizationProblemType { get; }
 
     public override IDeepCloneable Clone(Cloner cloner) => new LinearSolver(this, cloner);
@@ -118,13 +116,12 @@
 
     public bool ExportAsProto(string fileName, ProtoWriteFormat writeFormat = ProtoWriteFormat.ProtoBinary) =>
-      solver != null && solver.ExportModelAsProtoFormat(fileName, (int)writeFormat);
-
-    public SolverResponseStatus ImportFromMps(string fileName, bool? fixedFormat) => solver == null
-      ? SolverResponseStatus.Abnormal
-      : (SolverResponseStatus)solver.ImportModelFromMpsFormat(fileName, fixedFormat.HasValue, fixedFormat ?? false);
-
-    public SolverResponseStatus ImportFromProto(string fileName) => solver == null
-      ? SolverResponseStatus.Abnormal
-      : (SolverResponseStatus)solver.ImportModelFromProtoFormat(fileName);
+      solver != null && solver.ExportModelAsProtoFormat(fileName, (Google.OrTools.LinearSolver.ProtoWriteFormat)writeFormat);
+
+    public MPSolverResponseStatus ImportFromMps(string fileName, bool? fixedFormat) =>
+      solver?.ImportModelFromMpsFormat(fileName, fixedFormat.HasValue, fixedFormat ?? false) ??
+      (MPSolverResponseStatus)SolverResponseStatus.Abnormal;
+
+    public MPSolverResponseStatus ImportFromProto(string fileName) =>
+      solver?.ImportModelFromProtoFormat(fileName) ?? (MPSolverResponseStatus)SolverResponseStatus.Abnormal;
 
     public bool InterruptSolve() => solver?.InterruptSolve() ?? false;
@@ -135,13 +132,13 @@
     }
 
-    public virtual void Solve(ILinearProgrammingProblemDefinition problemDefintion, ref TimeSpan executionTime,
+    public virtual void Solve(ILinearProblemDefinition problemDefintion,
       ResultCollection results, CancellationToken cancellationToken) =>
-      Solve(problemDefintion, ref executionTime, results);
-
-    public virtual void Solve(ILinearProgrammingProblemDefinition problemDefinition, ref TimeSpan executionTime,
+      Solve(problemDefintion, results);
+
+    public virtual void Solve(ILinearProblemDefinition problemDefinition,
       ResultCollection results) =>
       Solve(problemDefinition, results, TimeLimit);
 
-    public virtual void Solve(ILinearProgrammingProblemDefinition problemDefinition, ResultCollection results,
+    public virtual void Solve(ILinearProblemDefinition problemDefinition, ResultCollection results,
       TimeSpan timeLimit) {
       if (solver == null) {
@@ -158,51 +155,18 @@
       ResultStatus resultStatus;
 
-      using (var parameters = new MPSolverParameters()) {
-        parameters.SetDoubleParam(MPSolverParameters.RELATIVE_MIP_GAP, RelativeGapTolerance);
-        parameters.SetDoubleParam(MPSolverParameters.PRIMAL_TOLERANCE, PrimalTolerance);
-        parameters.SetDoubleParam(MPSolverParameters.DUAL_TOLERANCE, DualTolerance);
-        parameters.SetIntegerParam(MPSolverParameters.PRESOLVE,
-          Presolve ? MPSolverParameters.PRESOLVE_ON : MPSolverParameters.PRESOLVE_OFF);
-        parameters.SetIntegerParam(MPSolverParameters.LP_ALGORITHM, (int)LpAlgorithm);
-        parameters.SetIntegerParam(MPSolverParameters.INCREMENTALITY,
-          Incrementality ? MPSolverParameters.INCREMENTALITY_ON : MPSolverParameters.INCREMENTALITY_OFF);
-        parameters.SetIntegerParam(MPSolverParameters.SCALING,
-          Scaling ? MPSolverParameters.SCALING_ON : MPSolverParameters.SCALING_OFF);
+      using (var parameters = new SolverParameters()) {
+        parameters.SetDoubleParam(SolverParameters.DoubleParam.RelativeMipGap, RelativeGapTolerance);
+        parameters.SetDoubleParam(SolverParameters.DoubleParam.PrimalTolerance, PrimalTolerance);
+        parameters.SetDoubleParam(SolverParameters.DoubleParam.DualTolerance, DualTolerance);
+        parameters.SetIntegerParam(SolverParameters.IntegerParam.Presolve,
+          (int)(Presolve ? SolverParameters.PresolveValues.PresolveOn : SolverParameters.PresolveValues.PresolveOff));
+        parameters.SetIntegerParam(SolverParameters.IntegerParam.Incrementality,
+          (int)(Incrementality ? SolverParameters.IncrementalityValues.IncrementalityOn : SolverParameters.IncrementalityValues.IncrementalityOff));
+        parameters.SetIntegerParam(SolverParameters.IntegerParam.Scaling,
+          (int)(Scaling ? SolverParameters.ScalingValues.ScalingOn : SolverParameters.ScalingValues.ScalingOff));
 
         if (!solver.SetSolverSpecificParametersAsString(SolverSpecificParameters))
           throw new ArgumentException("Solver specific parameters could not be set.");
 
-        if (!string.IsNullOrWhiteSpace(ExportModel)) {
-          var fileInfo = new FileInfo(ExportModel);
-
-          if (!fileInfo.Directory?.Exists ?? false) {
-            Directory.CreateDirectory(fileInfo.Directory.FullName);
-          }
-
-          bool exportSuccessful;
-          switch (fileInfo.Extension) {
-            case ".lp":
-              exportSuccessful = ExportAsLp(ExportModel);
-              break;
-
-            case ".mps":
-              exportSuccessful = ExportAsMps(ExportModel);
-              break;
-
-            case ".prototxt":
-              exportSuccessful = ExportAsProto(ExportModel, ProtoWriteFormat.ProtoText);
-              break;
-
-            case ".bin": // remove file extension as it is added by OR-Tools
-              exportSuccessful = ExportAsProto(Path.ChangeExtension(ExportModel, null));
-              break;
-
-            default:
-              throw new NotSupportedException("File format selected to export model is not supported.");
-          }
-        }
-
-        // TODO: show warning if file export didn't work (if exportSuccessful is false)
-
         resultStatus = (ResultStatus)solver.Solve(parameters);
       }
@@ -211,8 +175,6 @@
 
       problemDefinition.Analyze(solver, results);
-      results.AddOrUpdateResult("ResultStatus", new EnumValue<ResultStatus>(resultStatus));
-      results.AddOrUpdateResult("BestObjectiveValue", new DoubleValue(objectiveValue ?? double.NaN));
-
-      if (solver.IsMIP()) {
+
+      if (solver.IsMip()) {
         var objectiveBound = solver.Objective()?.BestBound();
         var absoluteGap = objectiveValue.HasValue && objectiveBound.HasValue
@@ -224,4 +186,8 @@
           : (double?)null;
 
+        if (resultStatus == ResultStatus.Optimal && absoluteGap.HasValue && !absoluteGap.Value.IsAlmost(0)) {
+          resultStatus = ResultStatus.OptimalWithinTolerance;
+        }
+
         results.AddOrUpdateResult("BestObjectiveBound", new DoubleValue(objectiveBound ?? double.NaN));
         results.AddOrUpdateResult("AbsoluteGap", new DoubleValue(absoluteGap ?? double.NaN));
@@ -229,8 +195,11 @@
       }
 
+      results.AddOrUpdateResult("ResultStatus", new EnumValue<ResultStatus>(resultStatus));
+      results.AddOrUpdateResult("BestObjectiveValue", new DoubleValue(objectiveValue ?? double.NaN));
+
       results.AddOrUpdateResult("NumberOfConstraints", new IntValue(solver.NumConstraints()));
       results.AddOrUpdateResult("NumberOfVariables", new IntValue(solver.NumVariables()));
 
-      if (solver.IsMIP() && solver.Nodes() >= 0) {
+      if (solver.IsMip() && solver.Nodes() >= 0) {
         results.AddOrUpdateResult(nameof(solver.Nodes), new DoubleValue(solver.Nodes()));
       }
@@ -243,5 +212,5 @@
     }
 
-    protected virtual Solver CreateSolver(OptimizationProblemType optimizationProblemType, string libraryName = null) {
+    protected virtual Solver CreateSolver(Solver.OptimizationProblemType optimizationProblemType, string libraryName = null) {
       if (!string.IsNullOrEmpty(libraryName) && !File.Exists(libraryName)) {
         var paths = new List<string> {
@@ -256,5 +225,5 @@
 
       try {
-        solver = new Solver(Name, (int)optimizationProblemType, libraryName ?? string.Empty);
+        solver = new Solver(Name, optimizationProblemType, libraryName ?? string.Empty);
       } catch {
         throw new InvalidOperationException($"Could not create {optimizationProblemType}.");
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/BopSolver.cs
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/BopSolver.cs	(revision 16581)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/BopSolver.cs	(revision 16582)
@@ -21,4 +21,5 @@
 
 using System;
+using Google.OrTools.LinearSolver;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -27,5 +28,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.MathematicalOptimization.LinearProgramming {
+namespace HeuristicLab.ExactOptimization.LinearProgramming {
 
   [Item("BOP", "BOP (https://developers.google.com/optimization/reference/bop/bop_solver/) can be used out of the box.")]
@@ -52,6 +53,8 @@
     }
 
-    protected override OptimizationProblemType OptimizationProblemType =>
-               OptimizationProblemType.BopIntegerProgramming;
+    protected override Solver.OptimizationProblemType OptimizationProblemType =>
+      Solver.OptimizationProblemType.BopIntegerProgramming;
+
+    public override IDeepCloneable Clone(Cloner cloner) => new BopSolver(this, cloner);
   }
 }
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/CoinOrSolver.cs
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/CoinOrSolver.cs	(revision 16581)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/CoinOrSolver.cs	(revision 16582)
@@ -20,11 +20,10 @@
 #endregion
 
-using System;
+using Google.OrTools.LinearSolver;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Optimization;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.MathematicalOptimization.LinearProgramming {
+namespace HeuristicLab.ExactOptimization.LinearProgramming {
 
   [Item("Clp/Cbc", "Clp (https://projects.coin-or.org/Clp) and Cbc (https://projects.coin-or.org/Cbc) can be used out of the box.")]
@@ -51,13 +50,10 @@
     public override bool SupportsStop => false;
 
-    protected override OptimizationProblemType OptimizationProblemType =>
+    protected override Solver.OptimizationProblemType OptimizationProblemType =>
       ProblemType == ProblemType.LinearProgramming
-        ? OptimizationProblemType.ClpLinearProgramming
-        : OptimizationProblemType.CbcMixedIntegerProgramming;
+        ? Solver.OptimizationProblemType.ClpLinearProgramming
+        : Solver.OptimizationProblemType.CbcMixedIntegerProgramming;
 
-    public override void Solve(ILinearProgrammingProblemDefinition problemDefinition, ResultCollection results, TimeSpan timeLimit) {
-      // TODO: warning that solver cannot be stopped or paused
-      base.Solve(problemDefinition, results, timeLimit);
-    }
+    public override IDeepCloneable Clone(Cloner cloner) => new CoinOrSolver(this, cloner);
   }
 }
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/CplexSolver.cs
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/CplexSolver.cs	(revision 16581)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/CplexSolver.cs	(revision 16582)
@@ -21,4 +21,5 @@
 
 using System;
+using Google.OrTools.LinearSolver;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -27,5 +28,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.MathematicalOptimization.LinearProgramming {
+namespace HeuristicLab.ExactOptimization.LinearProgramming {
 
   [Item("CPLEX", "CPLEX (https://www.ibm.com/analytics/cplex-optimizer) must be installed and licenced.")]
@@ -40,6 +41,9 @@
         "# for file format, see https://www.ibm.com/support/knowledgecenter/SSSA5P_12.8.0/ilog.odms.cplex.help/CPLEX/FileFormats/topics/PRM.html" + Environment.NewLine +
         "# for parameters, see https://www.ibm.com/support/knowledgecenter/SSSA5P_12.8.0/ilog.odms.cplex.help/CPLEX/Parameters/topics/introListTopical.html" + Environment.NewLine +
-        "# example:" + Environment.NewLine +
-        "# CPXPARAM_RandomSeed 10" + Environment.NewLine;
+        "# examples:" + Environment.NewLine +
+        "# CPXPARAM_RandomSeed 10" + Environment.NewLine +
+        "# CPXPARAM_LPMethod 4 # Barrier (LP)" + Environment.NewLine +
+        "# CPXPARAM_MIP_Strategy_SubAlgorithm 4 # Barrier (MIP)" + Environment.NewLine +
+        "# CPXPARAM_MIP_Strategy_Search 2 # Apply dynamic search (MIP)" + Environment.NewLine;
     }
 
@@ -53,8 +57,10 @@
     }
 
-    protected override OptimizationProblemType OptimizationProblemType =>
+    protected override Solver.OptimizationProblemType OptimizationProblemType =>
       ProblemType == ProblemType.LinearProgramming
-        ? OptimizationProblemType.CplexLinearProgramming
-        : OptimizationProblemType.CplexMixedIntegerProgramming;
+        ? Solver.OptimizationProblemType.CplexLinearProgramming
+        : Solver.OptimizationProblemType.CplexMixedIntegerProgramming;
+
+    public override IDeepCloneable Clone(Cloner cloner) => new CplexSolver(this, cloner);
   }
 }
